byte dataPin=22;//последовательный вход регистра сдвига
byte clockPin=24;//тактовый
byte latchPin=26;//защелка
byte An1=44;
byte An2=42;
byte An3=40;
byte An4=38;
byte zum=32;
int d,e,por1,por2;
long n1,n2;
/*
 * por1,por2-пороговые значения влажности для первого и второго горшков
 * An1-An4-аноды индикатора
 * с,d,e,m-сотни,десятки,единицы,тысячи
 * n-влажность почвы
 */
byte pump1=36;//насос1
byte pump2=34;//насос2
byte but1=11;//кнопка переключения режимов
byte but2=13; //кнопка +
byte but3=12; //кнопка -
byte regime=1;
unsigned long t;
boolean z;//предыдущее состояние кнопки
void setup() {
pinMode(latchPin,OUTPUT);
pinMode(dataPin,OUTPUT);
pinMode(clockPin, OUTPUT);
pinMode(An1,OUTPUT);
pinMode(An2,OUTPUT);
pinMode(An3,OUTPUT);
pinMode(An4,OUTPUT);
pinMode(pump1,OUTPUT);
pinMode(pump2,OUTPUT);
pinMode(but1,INPUT);
pinMode(but2,INPUT);
pinMode(but3,INPUT);

}
void loop() {
 
if(analogRead(A8)<100) {
   melody();
}

if(regime==1){
 n1=izmer(1);
 n2=izmer(2);
t =millis();
while(millis()<t+100){
  number(n1);
 if(digitalRead(but1)==1&&z==0) break;
};
 };
 if(regime==2){
  n1=izmer(1);
 n2=izmer(2);
t =millis();
while(millis()<t+100){
 if(digitalRead(but1)==1&&z==0) break;
 number(n2);
 };
 };
  if(regime==3){
 n1=izmer(1);
 n2=izmer(2);
number(por1);
 };
 if(regime==4){
   n1=izmer(1);
 n2=izmer(2);
number(por2);
 };
 if(regime>4){
  regime=1;
 };

 if(digitalRead(but1)==1&&z==0) drebezg(1);
  if(digitalRead(but2)==1) drebezg(2);
   if(digitalRead(but3)==1) drebezg(3);
 
if(digitalRead(but1)==0&&z==1){
  delay(5);
  if(digitalRead(but1)==0&&z==1){
    z=0;
  };
 };
 if(n1<por1){ 
digitalWrite(pump1,LOW);
 }else{
 digitalWrite(pump1,HIGH) ;
 }
 if(n2<por2){ 
  digitalWrite(pump2,LOW); 
 }else{
digitalWrite(pump2,HIGH);
};
}

void drebezg(int i){
  if (i==1){
  delay(5);
  if(digitalRead(but1)==1&&z==0){
    regime++;
    z=1;
  };
  };
  
    if (i==2){
  delay(5);
  if(digitalRead(but2)==1){
    if (regime==3&&por1<99){
      por1++;
      t=millis();
      while(millis()<t+200){
        number(por1);
        };
    };
    if (regime==4&&por2<99){
      por2++;
       t=millis();
      while(millis()<t+200){
        number(por2);
        };
    };
  };
  };
      if (i==3){
  delay(5);
  if(digitalRead(but3)==1){
    if (regime==3&&por1>0){
      por1--;
       t=millis();
      while(millis()<t+200){
        number(por1);
        };
    };
    if (regime==4&&por2>0){
      por2--;
       t=millis();
      while(millis()<t+200){
        number(por2);
        };
    };
  };
 };
}

int izmer(int k){
 if(k==1){
 n1=0;
 for(int i=1;i<11;i++){
 n1=n1+analogRead(A9);
 };
 n1=n1/10;
 n1=map(n1,250,500,0,99);
 n1=constrain(n1,0,99);
 return n1;
 };
  if(k==2){
 n2=0;
 for(int i=1;i<11;i++){
 n2=n2+analogRead(A10);
 };
 n2=n2/10;
 n2=map(n2,250,500,0,99);
 n2=constrain(n2,0,99);
 return n2;
 };
}



void razryd(int n){
if(n==0){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B00000011);
digitalWrite(latchPin, HIGH);
};
if(n==1){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B10011111);
digitalWrite(latchPin, HIGH);
};
if(n==2){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B00100101);
digitalWrite(latchPin, HIGH);
};
if(n==3){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B00001101);
digitalWrite(latchPin, HIGH);
};
if(n==4){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B10011001);
digitalWrite(latchPin, HIGH);
};
if(n==5){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B01001001);
digitalWrite(latchPin, HIGH);
};
if(n==6){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B01000001);
digitalWrite(latchPin, HIGH);
};
if(n==7){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B00011111);
digitalWrite(latchPin, HIGH);
};
if(n==8){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B00000001);
digitalWrite(latchPin, HIGH);
};
if(n==9){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B00001001);
digitalWrite(latchPin, HIGH);
};
if(n==10){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B11111101);//дефис
digitalWrite(latchPin, HIGH);
};
if(n==11){
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B11010101);//буква п
digitalWrite(latchPin, HIGH);
};
}

void number (int i){
  d=i/10;
  e=i-d*10;
  digitalWrite(An1,HIGH);
  digitalWrite(An2,LOW);
   digitalWrite(An3,LOW);
   digitalWrite(An4,LOW);
   if(regime==1||regime==3)razryd(1);//в первом или третьем режиме выводим "1" на первый разряд
   if(regime==2||regime==4)razryd(2);//во втором или четветром режиме выводим "2" на первый разряд
   delay(5);
   digitalWrite(An1,LOW);
  digitalWrite(An2,HIGH);
   digitalWrite(An3,LOW);
   digitalWrite(An4,LOW);
   if(regime==1||regime==2)razryd(10);//выводим дефис на второй разряд
    if(regime==3||regime==4)razryd(11);//выводим букву "п" на второй разряд
   delay(5);
   digitalWrite(An1,LOW);
  digitalWrite(An2,LOW);
   digitalWrite(An3,HIGH);
   digitalWrite(An4,LOW);
   razryd(d);
   delay(5);
   digitalWrite(An1,LOW);
  digitalWrite(An2,LOW);
   digitalWrite(An3,LOW);
   digitalWrite(An4,HIGH);
   razryd(e);
   delay(5);
   }

void melody(){
  digitalWrite(pump1,HIGH);
 digitalWrite(pump2,HIGH); 
 digitalWrite(An1,HIGH);
 digitalWrite(An2,HIGH);
 digitalWrite(An3,HIGH);
 digitalWrite(An4,HIGH);
digitalWrite(latchPin,LOW);
shiftOut(dataPin, clockPin,LSBFIRST,B11111101);//дефис
digitalWrite(latchPin, HIGH);
tone(zum, 392, 450);
delay(450);
noTone(zum);
delay(20);
tone(zum, 392, 450);
delay(450);
noTone(zum);
delay(20);
tone(zum, 392, 450);
delay(350);
noTone(zum);
delay(100);
tone(zum, 311, 350);
delay(350);
tone(zum, 466, 200);
delay(200);
tone(zum, 392, 450);
delay(450);
tone(zum, 311, 350);
delay(350);
tone(zum, 466, 200);
delay(200);
tone(zum, 392, 800);
delay(800);
tone(zum, 587, 450);
delay(450);
tone(zum, 587, 450);
delay(450);
tone(zum, 587, 450);
delay(450);
tone(zum, 622, 350);
delay(350);
tone(zum, 466, 200);
delay(200);
tone(zum, 369, 450);
delay(450);
tone(zum, 311, 350);
delay(350);
tone(zum, 466, 200);
delay(200);
tone(zum, 392, 800);
delay(800);
 noTone(zum);
 delay(1000);
}
